/** \file
*/
//---------------------------------------------------------------------------

#ifndef SettingsH
#define SettingsH
//---------------------------------------------------------------------------
#include <System.hpp>

class Settings
{
public:
	int Read(AnsiString asFileName);
	int Write(AnsiString asFileName);
	void SetDefault(void);
	struct _gui
	{
		enum { SCALING_MIN = 50 };
		enum { SCALING_MAX = 200 };
		int scalingPct;					///< scaling (percentage)
	} gui;
	struct _frmMain
	{
		int iPosX, iPosY;				///< main window coordinates
		int iHeight, iWidth;			///< main window size
		bool bWindowMaximized;			///< is main window maximize?
		bool bAlwaysOnTop;
	} frmMain;
	struct _Logging
	{
		bool bLogToFile;
		bool bFlush;
		enum {
			MIN_MAX_FILE_SIZE = 0,
			MAX_MAX_FILE_SIZE = 1000*1024*1024
		};
		enum {
            DEF_MAX_FILE_SIZE = 10*1024*1024
        };
		int iMaxFileSize;
		unsigned int iMaxUiLogLines;
	} Logging;
	struct _SerialPort
	{
		AnsiString name;
		int baud;
		AnsiString parity;
		int data_bit;
		int stop_bit;
		bool openAtStartup;
		static const AnsiString namePrefix;
		_SerialPort(void):
			name("COM10"),
			baud(57600),
			parity("N"), //parity("E"),
			data_bit(8),
			stop_bit(1),
			openAtStartup(false)
		{}
	} SerialPort;

	struct _UartMtTest
	{
		unsigned int dataCountMin;
		unsigned int dataCountMax;
		enum { MIN_TX_CNT = 1 };
		enum { MAX_TX_CNT = 2000 };

		unsigned int intervalMin;
		unsigned int intervalMax;
		enum { INTERVAL_MIN = 10 };
		enum { INTERVAL_MAX = 100000 };

		_UartMtTest(void):
			dataCountMin(MIN_TX_CNT),
			dataCountMax(MAX_TX_CNT/10),
			intervalMin(30),
			intervalMax(300)
		{}
		void Validate(void);
	} UartMtTest;
};

extern Settings appSettings;

#endif
