#ifndef __INCLUDE_MERSENNE_TWISTER_H
#define __INCLUDE_MERSENNE_TWISTER_H

#include <stdint.h>

#define MT_STATE_VECTOR_LENGTH 624	/* changes require also updating STATE_VECTOR_M */

#ifdef __cplusplus 
extern "C" { 
#endif

struct mt_rand {
	uint32_t mt[MT_STATE_VECTOR_LENGTH];
	int32_t index;
};

/**
* Initializes random number generator from a given seed.
*/
void mt_rand_init(struct mt_rand *inst, uint32_t seed);

/**
 * Generates a pseudo-randomly generated long.
 */
uint32_t mt_rand_get_u32(struct mt_rand *inst);

#ifdef __cplusplus
}
#endif

#endif
